# -*- coding: UTF-8 -*-

import os
home = os.environ.get('HOME')

import math              as m
import numpy             as np

# from lib_bin import *
def int2hex(n,nbits):
    """ 
    affiche la représentation hexadécimale d'un nombre int avec complément à 2  
    pour les valeurs négatives
    début: 9 janvier 2015
    """
    if (nbits % 4) != 0 :
        return 'ERROR 1!'
    spec='0'+str(nbits/4)+'x'
    if n >= (-2**(nbits-1)) and n <= (2**(nbits-1)-1) :
        return format(n, spec) if n>=0 else format(2**nbits+n, spec)
    else :
        return 'ERROR 2!'

print '######################### SIGNAUX SINUSOÏDAUX ############################'
print '######################### SÉRIE 3             ############################'
print
nbits_wf  = 14+2
min_wf    = -pow(2,nbits_wf-1)
max_wf    = +pow(2,nbits_wf-1)-1
n_fft     = 256
print 'bits for waveforms =', nbits_wf
print 'min value for WF   =', min_wf
print 'max value for WF   =', max_wf
print 'points for FFT     =', n_fft

"""
print
nn = 5
if nn == 15 :
    ampl = pow(2.,nn)-1
else :
    ampl = pow(2.,nn)
phi = m.pi * 0.
i_f = 32.
f = i_f/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2.0*m.pi*f*t+phi)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'bits for amplitude      =', nn    
print 'i for frequency         =', i_f
print 'cosine amplitude          =', ampl
print 'cosine amplitude/2        =', ampl/2
print 'cosine amplitude/sqrt(2)  =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)        =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)    =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2)) =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)
"""

"""
for i in xrange(n_fft) :
    print '{0:05x} {0:16b} {0:6d}'.format(x_int16[i])
    print '', int2hex(x_int16[i],16), int2bin(x_int16[i],16)
"""
"""
for i in xrange(n_fft) :
    print '', int2hex(x_int16[i],16)
"""
 
directory = home     + '/DD pc-p-chust/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/'
#directory = '/WIN/Users/chust/DD CHUST/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/' 



print
nn = 2
ampl = pow(2,nn)
nbits_used = nn+1
phi = 0.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
nn = 2
ampl = pow(2,nn)
nbits_used = nn+1
phi = 90.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
nn = 2
ampl = pow(2,nn)
nbits_used = nn+1
phi = 45.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename






print
nn = 2
ampl = pow(2,nn) + 1
nbits_used = nn+1
phi = 0.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
nn = 2
ampl = pow(2,nn)  + 1
nbits_used = nn+1
phi = 90.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
nn = 2
ampl = pow(2,nn)  + 1
nbits_used = nn+1
phi = 45.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename






print
nn = 2
ampl = pow(2,nn) + 2
nbits_used = nn+1
phi = 0.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
nn = 2
ampl = pow(2,nn)  + 2
nbits_used = nn+1
phi = 90.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
nn = 2
ampl = pow(2,nn)  + 2
nbits_used = nn+1
phi = 45.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename







print
nn = 2
ampl = pow(2,nn) + 3
nbits_used = nn+1
phi = 0.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
nn = 2
ampl = pow(2,nn)  + 3
nbits_used = nn+1
phi = 90.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
nn = 2
ampl = pow(2,nn)  + 3
nbits_used = nn+1
phi = 45.
i_f = 32
f = float(i_f)/n_fft
t = np.arange(n_fft)
x = ampl * np.cos(2*m.pi*f*t + phi*m.pi/180)
x_int16 = np.zeros(n_fft,dtype=np.int16)
for i in xrange(n_fft) :
    x_int16[i] = int(round(x[i]))
    
print 'number of bits used      =', nbits_used    
print 'i for frequency          =', i_f
print 'cosine phase             =', phi
print 'cosine amplitude         =', ampl
print 'cosine amplitude/2       =', ampl/2.
print 'cosine amplitude/sqrt(2) =', round(ampl/m.sqrt(2),2)
print 'sqrt(ampl^2 / 3)         =', np.sqrt(ampl**2. / 3).round(2)
print 'x_int16 = ', x_int16
print '     mean(|x_int16|)     =', ( sum(abs(x_int16)) / len(x_int16) ).round(2)
print 'sqrt(mean(|x_int16|^2))  =', ( np.sqrt(sum(abs(x_int16)**2.)/len(x_int16)) ).round(2)

filename = 'cos_ampl'+str(int(ampl))+'_freq'+str(i_f)+'_phi'+format(phi,'.1f')+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x_int16[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename














