# -*- coding: UTF-8 -*-

import os
home = os.environ.get('HOME')

import math              as m
import numpy             as np

# from lib_bin import *
def int2hex(n,nbits):
    """ 
    affiche la représentation hexadécimale d'un nombre int avec complément à 2  
    pour les valeurs négatives
    début: 9 janvier 2015
    """
    if (nbits % 4) != 0 :
        return 'ERROR 1!'
    spec='0'+str(nbits/4)+'x'
    if n >= (-2**(nbits-1)) and n <= (2**(nbits-1)-1) :
        return format(n, spec) if n>=0 else format(2**nbits+n, spec)
    else :
        return 'ERROR 2!'

print '######################### BRUIT BLANC LARGE BANDE #######################'
print '######################### SÉRIE 5                 #######################'
print
nbits_wf  = 14+2
min_wf    = -pow(2,nbits_wf-1)
max_wf    = +pow(2,nbits_wf-1)-1
n_fft     = 256
print 'bits for waveforms =', nbits_wf
print 'min value for WF   =', min_wf
print 'max value for WF   =', max_wf
print 'points for FFT     =', n_fft

 
#directory = home                + '/DD pc-p-chust/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/'
directory =  '/WIN/Users/chust/' +      '/DD CHUST/Missions/Solar Orbiter/LFR/Python/Emulator/signaux_fft/' 


print
print 'BROADBAND NOISE'
ampl = 16
print 'noise amplitude   =', ampl
a = -ampl
b = +ampl
x = np.random.randint(a,b,n_fft)

print '     mean(|x|)    =', ( sum(abs(x)) / float(len(x)) ).round(2)
print 'sqrt(mean(|x|^2)) =', ( np.sqrt(sum(abs(x)**2.)/len(x)) ).round(2)
print 'sqrt(ampl^2 / 3)  =', ( np.sqrt(ampl**2. / 3) ).round(2)
print 'x                 =', x

filename = 'noise_ampl'+str(int(ampl))+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
print 'BROADBAND NOISE'
ampl = int(round(16. * m.sqrt(3)))
print 'noise amplitude   =', ampl
a = -ampl
b = +ampl
x = np.random.randint(a,b,n_fft)

print '     mean(|x|)    =', ( sum(abs(x)) / float(len(x)) ).round(2)
print 'sqrt(mean(|x|^2)) =', ( np.sqrt(sum(abs(x)**2.)/len(x)) ).round(2)
print 'sqrt(ampl^2 / 3)  =', ( np.sqrt(ampl**2. / 3) ).round(2)
print 'x                 =', x

filename = 'noise_ampl'+str(int(ampl))+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
print 'BROADBAND NOISE'
ampl = int(round(16. * m.sqrt(3)))*2
print 'noise amplitude   =', ampl
a = -ampl
b = +ampl
x = np.random.randint(a,b,n_fft)

print '     mean(|x|)    =', ( sum(abs(x)) / float(len(x)) ).round(2)
print 'sqrt(mean(|x|^2)) =', ( np.sqrt(sum(abs(x)**2.)/len(x)) ).round(2)
print 'sqrt(ampl^2 / 3)  =', ( np.sqrt(ampl**2. / 3) ).round(2)
print 'x                 =', x

filename = 'noise_ampl'+str(int(ampl))+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename


print
print 'BROADBAND NOISE'
ampl = int(round(16. * m.sqrt(3)))*3
print 'noise amplitude   =', ampl
a = -ampl
b = +ampl
x = np.random.randint(a,b,n_fft)

print '     mean(|x|)    =', ( sum(abs(x)) / float(len(x)) ).round(2)
print 'sqrt(mean(|x|^2)) =', ( np.sqrt(sum(abs(x)**2.)/len(x)) ).round(2)
print 'sqrt(ampl^2 / 3)  =', ( np.sqrt(ampl**2. / 3) ).round(2)
print 'x                 =', x

filename = 'noise_ampl'+str(int(ampl))+'.dat'    
f = open(directory+filename, 'w')
for i in xrange(n_fft) :
    f.write(int2hex(x[i],16))
    f.write('\n')    
f.close
print 'this file has been printed: ', filename





